import { Meta, Canvas, Story } from '@storybook/addon-docs'
import { Tiles } from './MMap.stories.js'

<Meta title="Map/Readme" />

# Display a map

```import { MMap } from '@atlastories.app/vue-maplibre'```

Set tiles, trigger Maplibre methods and observe events.

## Height

Map component must have a height, either from a style attribute, or using it's parent height.
```
<m-map style="height:300px" />
```
```
<div style="height: 300px">
  <m-map />
</div>
```

## Tiles

The required prop `tiles` replace the style option from mapLibre, it can be an url to the json or an object following the [style specifications](https://maplibre.org/maplibre-gl-js-docs/style-spec/).

```
<m-map
  style="height: 300px"
  tiles="https://demotiles.maplibre.org/style.json" />
```

<Canvas>
  <Story
    name="Tiles">
    {Tiles.bind({})}
   </Story>
</Canvas>

## v-model

`center`, `zoom`, `pitch`, `bearing` and `padding` are two-way binded props.
For example, you can use `v-model:center` and `v-model:zoom`
to programmatically focus on a place, or watch map to trigger api calls
depending on map state.

<Canvas>
  <Story id="map-mmap--v-model" />
</Canvas>

## Animation

When `animation` prop is defined with an [animationOptions object](https://maplibre.org/maplibre-gl-js-docs/api/properties/#animationoptions), the map will smoothly change it's state.

<Canvas>
  <Story id="map-mmap--animation" />
</Canvas>

## Methods

You can trigger any method from MapLibre map. You can access the map object from `load` event or using a `ref`.

<Canvas>
  <Story id="map-mmap--methods" />
</Canvas>

## Events

`<m-map>` component has [a bunch of events to observe](https://maplibre.org/maplibre-gl-js-docs/api/map/#map-events). Please note that `@load` event data is the Map instance.

Here is an example with `@movestart`, `@moveend` and `@click`.

<Canvas>
  <Story id="map-mmap--events" />
</Canvas>

## Languages

The `lang` property let you define the map language.

<Canvas>
  <Story id="map-mmap--lang" />
</Canvas>

# Add a marker

```import { MMap, MMarker } from '@atlastories.app/vue-maplibre'```

Add a marker to the map, with a custom content and popup.

## Add to map

`<m-marker>` must be a child of `<m-map>` and it's `lngLat` prop is required and must follow [lngLat format](https://maplibre.org/maplibre-gl-js-docs/api/geography/#lnglat).

<Canvas>
  <Story id="map-mmarker--add" />
</Canvas>

## Custom marker

Use the default slot to create a custom marker, html content replaces the default marker.

<Canvas>
  <Story id="map-mmarker--custom" />
</Canvas>

## Add a popup

The named slot `popup` is used to add `<m-popup>` component to the marker.

<Canvas>
  <Story id="map-mmarker--popup" />
</Canvas>

## Marker events

`<m-marker>` has a `@click` event, and [few others](https://maplibre.org/maplibre-gl-js-docs/api/markers/#marker-events).

In the following example a click on the marker toggle it's draggable property, and the dragend event update it's position.

<Canvas>
  <Story id="map-mmarker--events" />
</Canvas>
